global regcount tdrtable() EGreport LItable()
set LogFlag 1
set EGreport 0

# Register and RAM table: Name : Offset address : Nbits : Nlocs 
set tdrtable(0)		{"Card Control		"   0x0000 16 1 }
set tdrtable(1)		{"Interrupt Control	"   0x0008 16 1 }
set tdrtable(2)		{"Interrupt Select	"   0x000C 16 1 }
set tdrtable(3)		{"Group A Enable	"   0x010C 16 1 }
set tdrtable(4)		{"Group A Invert	"   0x0108 16 1 }
set tdrtable(5)		{"Group A Mode		"   0x0100 16 1 }
set tdrtable(6)		{"Group B Enable	"   0x020C 16 1 }
set tdrtable(7)		{"Group B Invert	"   0x0208 16 1 }
set tdrtable(8)		{"Group B Mode		"   0x0200 16 1 }
set tdrtable(9)		{"LI Source		"   0x0300 16 4 }
set tdrtable(10)	{"Input Chip control	"   0x0400 16 1 }
set tdrtable(11)	{"Readout Idents	"   0x0540 32 6 }
set tdrtable(12)	{"Load Timestamp	"   0x0600 32 1 }

set regcount 13

# Logic Inspection register test  : 
# Name  : chip number : nbits Signal : nbits Channel :signal mask : channel mask

set LItable(0)		{"Gate, Veto	" 2 3 6 7 63}
set LItable(1)		{"ADC Readout	" 3 3 6 7 63}
set LItable(2)		{"ADC32  	" 1 5 6 31 63}
set LItable(3)		{"VXI, SHARC	" 4 8 8 255 127}



# A simple read at each of the base addresses
proc test1 {} {
global regcount tdrtable
	for {set i 0} {$i < $regcount} {incr i} {
	set reg_address [ lindex $tdrtable($i) 1 ]
	rdl $reg_address
	}
}
# Addressing test
proc test2 {} {
global regcount tdrtable LogFlag EGreport
	set LogFlag 0 
	set EGreport -1
	for {set i 0} {$i < $regcount} {incr i} {
	   set reg_address [ lindex $tdrtable($i) 1 ]
	   set nlocs [lindex $tdrtable($i) 3 ] 
	   for { set j 0} { $j < $nlocs } {incr j } {
		set id [expr $j + $reg_address]
		wrl $reg_address $id
		set reg_address [ expr  $reg_address +  4  ]
	   }
	}
	log { All writes done for Identity test }
	update idletasks
	for {set i 0} {$i < $regcount} {incr i} {
	   set reg_address [ lindex $tdrtable($i) 1 ]
	   set nlocs [ lindex $tdrtable($i) 3 ] 
	   set nbits [ lindex $tdrtable($i) 2 ] 
	   for { set j 0} { $j <  $nlocs } {incr j } {
		set b [rdl $reg_address]
		set mask [ expr 1 << $nbits ]
		set mask [ expr $mask -1 ]
		set b [ expr $b & $mask ]
		set id [expr $j + $reg_address]
		set a [ expr $id & $mask ]
		if { $b != $a } {
		  log "Error ----[ lindex $tdrtable($i) 0 ] [format "0x%04x" $reg_address] [format "0x%08x" $a] [format "0x%08x" $b] "
		  update idletasks
		}
		set reg_address [ expr  $reg_address + 4]
	   }
	}
	log { All Reads done for Identity test }
	update idletasks
}
# Running ones, and noughts test
proc test3 {} {
global regcount tdrtable LogFlag EGreport
	set LogFlag 0 
	set EGreport -1
	for { set i 0} { $i < $regcount } { incr i } {
	   log "[lindex $tdrtable($i) 0]"
	   update idletasks
	   set reg_address [ lindex $tdrtable($i) 1 ]
	   set nlocs [ lindex $tdrtable($i) 3 ] 
	   set nbits [ lindex $tdrtable($i) 2 ] 
	   set mask  [ expr 1 << $nbits ]
	   set mask  [ expr $mask -1 ]
	   for { set j 0 } { $j < $nlocs } { incr j } {
		set l 1
		for { set k 0 } { $k < $nbits } { incr k } {
		    wrl $reg_address $l
		    set b [rdl $reg_address]
		    set b [ expr $b & $mask ]
		    set a [ expr $l & $mask ]
		    if { $b != $a } {
		      log "[ lindex $tdrtable($i) 0 ] [format "0x%04x" $reg_address] [format "0x%08x" $a] [format "0x%08x" $b] "
		      update idletasks
		    }
		    set l [expr $l << 1 ]
		}
		wrl $reg_address 0 ;# to catch the board reset bits
		set reg_address [ expr  $reg_address + 4]
	   }
	   set reg_address [ lindex $tdrtable($i) 1 ]
	   for { set j 0 } { $j < $nlocs } { incr j } {
		set l -2
		for { set k 0 } { $k < $nbits } { incr k } {
		    wrl $reg_address $l
		    set b [rdl $reg_address]
		    set b [ expr $b & $mask ]
		    set a [ expr $l & $mask ]
		    if { $b != $a } {
		      log "[ lindex $tdrtable($i) 0 ] [format "0x%04x" $reg_address] [format "0x%08x" $a] [format "0x%08x" $b] "
		      update idletasks
		    }
		    set l [expr ( $l << 1 ) + 1]
		}
		wrl $reg_address 0 ;# to catch the board reset bits
		set reg_address [ expr  $reg_address + 4]
	   }
	}
}

# Running the tests
set-busy
test1
test2
test3
set LogFlag 1
set EGreport 0
clear-busy
log {That's all Folks !}
update idletasks
